// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package ed25519blake2b

import (
	"errors"

	"go.cypherpunks.su/keks/cm/sign/ed25519-blake2b/ed25519"
)

func Verify(pub, signed, signature []byte) (valid bool, err error) {
	if len(pub) != 32 {
		err = errors.New("invalid ed25519 public key size")
		return
	}
	var pk *ed25519.PublicKey
	pk, err = ed25519.NewPublicKey(pub)
	if err != nil {
		return
	}
	valid = ed25519.Verify(pk, signed, signature) == nil
	return
}

func VerifyPrehash(pub, hsh, signature []byte) (valid bool, err error) {
	if len(pub) != 32 {
		err = errors.New("invalid ed25519 public key size")
		return
	}
	var pk *ed25519.PublicKey
	pk, err = ed25519.NewPublicKey(pub)
	if err != nil {
		return
	}
	valid = ed25519.VerifyPH(pk, hsh, signature, "") == nil
	return
}
